# LEAM: Localization by Exhaustive Aggregated Matching

## Top-level Executables
* `./run_test`: run tests to verify (some aspects of) implementation
* `./run_leam`: Perform full pipeline (will take about an hour), including decompression of data, topological voxel generation, DDF generation and automatic evaluation. Some graphs will be generated.


## Codes for Debugging & Understanding
* `./check_*.py`: do some partial calculation for debugging purpose
* `./interact_*.py`: show components with VTK

Some of these codes may no longer work due to API changes.


## Core Dependencies
* Python (2.7.*)
	* [numpy](http://www.numpy.org/)
	* [scipy](http://www.scipy.org/)
	* [cython](http://www.cython.org/)
	* [tools3d](https://github.com/xanxys/tools3d) (fetched by git automatically)
* Haskell (GHC 7.*), older version might work.
	* [json](http://hackage.haskell.org/package/json)
	* [messagepack](http://hackage.haskell.org/package/msgpack)
	* [Vec](http://hackage.haskell.org/package/Vec)

## Optional Dependencies
* [fish](http://ridiculousfish.com/shell/) (if you want to `./run_leam` or `./run_test`)
* [test-framework](http://hackage.haskell.org/package/test-framework) (for `./run_test`)
* [test-framework-th](http://hackage.haskell.org/package/test-framework-th) (for `./run_test`)
* [test-framework-hunit](http://hackage.haskell.org/package/test-framework-hunit) (for `./run_test`)
* python
	* [VTK](http://www.vtk.org/) (only for `./interact_*.py`)


## Running
Run the following:

	mkdir leam_session
	cd leam_session
	../run_leam

This will create some intermediate files and evaluation result.

If you don't want to install fish, you can manually run a few commands mentioned there.


## LICENSE
The code (excluding libraries written by others) is provided under FreeBSD license.
