import numpy as np
import struct

def dumpSimpleFVXL(arr, path):
	size_desc ='!III'
	voxel_desc = '!c'

	f = open(path, 'wb')
	f.write(struct.pack(size_desc, *arr.shape[:3]))
	if arr.ndim == 3:
		f.write(struct.pack(voxel_desc, 'o'))
	elif arr.ndim == 4 and arr.shape[3]==4:
		f.write(struct.pack(voxel_desc, 'c'))
	else:
		raise ValueError('non-supported voxel format')
	f.write(arr.astype(np.uint8).tostring())
	f.close()

def loadSimpleFVXL(path):
	size_desc ='!III'
	voxel_desc = '!c'

	f = open(path, 'rb')
	shape = struct.unpack(size_desc, f.read(struct.calcsize(size_desc)))
	voxel = struct.unpack(voxel_desc, f.read(struct.calcsize(voxel_desc)))
	if voxel == ('o',):
		return np.fromstring(f.read(shape[0]*shape[1]*shape[2]), dtype=np.uint8).reshape(shape)
	elif voxel == ('c',): # this should be o1c3 or c3o1
		return np.fromstring(f.read(shape[0]*shape[1]*shape[2]*4), dtype=np.uint8).reshape(shape+[4])
	else:
		raise IOError('unexpected voxel descriptor %s'%voxel)
