#!/usr/bin/python
from __future__ import division, print_function
import numpy as np
import math
import msgpack
import sys
from tools3d.mesh import Mesh

def is_flat_mesh(o):
	"""
	Check roughly if o is likely to be "flat triangle mesh"
	https://gist.github.com/4425813
	"""
	return (type(o) is dict and 'property' in o and 'data' in o)

def is_object(o):
	return (type(o) is dict and 'mesh' in o and is_flat_mesh(o['mesh']))

def convert(objs):
	return {
		'objects': objs
	}


def annotate(path_in, path_out):
	o = msgpack.unpack(open(path_in, 'rb'))
	
	if is_flat_mesh(o):
		print('Provided file seems like a flat triangle mesh.')
		print('Use objects instead.')
	elif (type(o) is list or type(o) is tuple) and is_object(o[0]):
		msgpack.pack(convert(o), open(path_out, 'wb'))
	elif type(o) is dict and 'objects' in o:
		print('supplied file seems to be already annotated')
	else:
		raise NotImplementedError("couldn't understand supplied file")

if __name__ == '__main__':
	annotate(*sys.argv[1:])
