from __future__ import print_function, division
import unittest
import index as idx
import localize as loc
import numpy as np
import math

class LocalizeTestCase(unittest.TestCase):
	def setUp(self):
		o = {
			'grid': {
				'aunit': math.pi/2,
				'lunit': 0.25,
				'x': 1,
				'y': 1,
				'z': 1
			},
			'samples': np.array([[1,1.1]]*8,np.float32).tostring()
		}

		self.index = idx.Index(o)

	def test_any(self):
		dev = loc.ODeviceModel()
		dmap = np.empty([dev.height,dev.width], np.float32)
		dmap[:] = 1.05 # in between 1 and 1.1
		
		locs = self.index.localize(dev, dmap)
		self.assertEqual(len(locs), 2*4*4) # all rotations
